Index: trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7711)
@@ -1065,18 +851,46 @@
                  cen.y + axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
                  cen.z + axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
-      glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-                 cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-                 cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
-      glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-                 cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-                 cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+      glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
+                 cen.y + axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
+                 cen.z + axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
       glEnd();
-    }
-
-
-    if( drawMode & DRAW_BV_BLENDED)
-      glColor3f(color.x, color.y, color.z);
-    }
-
+
+
+      if( drawMode & DRAW_BV_BLENDED)
+      {
+        glBegin(GL_QUADS);
+        glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
+                   cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
+                   cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
+        glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
+                   cen.y + axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
+                   cen.z + axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
+        glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
+                   cen.y + axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
+                   cen.z + axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
+        glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
+                   cen.y - axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
+                   cen.z - axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
+        glEnd();
+
+        glBegin(GL_QUADS);
+        glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
+                   cen.y - axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
+                   cen.z - axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
+        glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
+                   cen.y + axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
+                   cen.z + axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
+        glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                   cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                   cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+        glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                   cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                   cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+        glEnd();
+      }
+
+      if( drawMode & DRAW_BV_BLENDED)
+        glColor3f(color.x, color.y, color.z);
+    }
   }
 
@@ -1089,19 +903,19 @@
         glColor4f(color.x, color.y, color.z, .6);
 
-    /* now draw the separation plane */
-    Vector a1 = this->bvElement->axis[(this->longestAxisIndex + 1)%3];
-    Vector a2 = this->bvElement->axis[(this->longestAxisIndex + 2)%3];
-    Vector c = *this->bvElement->center;
-    float l1 = this->bvElement->halfLength[(this->longestAxisIndex + 1)%3];
-    float l2 = this->bvElement->halfLength[(this->longestAxisIndex + 2)%3];
-    glBegin(GL_QUADS);
-    glVertex3f(c.x + a1.x * l1 + a2.x * l2, c.y + a1.y * l1+ a2.y * l2, c.z + a1.z * l1 + a2.z * l2);
-    glVertex3f(c.x - a1.x * l1 + a2.x * l2, c.y - a1.y * l1+ a2.y * l2, c.z - a1.z * l1 + a2.z * l2);
-    glVertex3f(c.x - a1.x * l1 - a2.x * l2, c.y - a1.y * l1- a2.y * l2, c.z - a1.z * l1 - a2.z * l2);
-    glVertex3f(c.x + a1.x * l1 - a2.x * l2, c.y + a1.y * l1- a2.y * l2, c.z + a1.z * l1 - a2.z * l2);
-    glEnd();
-
-    if( drawMode & DRAW_BV_BLENDED)
-      glColor4f(color.x, color.y, color.z, 1.0);
+      /* now draw the separation plane */
+      Vector a1 = this->bvElement->axis[(this->longestAxisIndex + 1)%3];
+      Vector a2 = this->bvElement->axis[(this->longestAxisIndex + 2)%3];
+      Vector c = this->bvElement->center;
+      float l1 = this->bvElement->halfLength[(this->longestAxisIndex + 1)%3];
+      float l2 = this->bvElement->halfLength[(this->longestAxisIndex + 2)%3];
+      glBegin(GL_QUADS);
+      glVertex3f(c.x + a1.x * l1 + a2.x * l2, c.y + a1.y * l1+ a2.y * l2, c.z + a1.z * l1 + a2.z * l2);
+      glVertex3f(c.x - a1.x * l1 + a2.x * l2, c.y - a1.y * l1+ a2.y * l2, c.z - a1.z * l1 + a2.z * l2);
+      glVertex3f(c.x - a1.x * l1 - a2.x * l2, c.y - a1.y * l1- a2.y * l2, c.z - a1.z * l1 - a2.z * l2);
+      glVertex3f(c.x + a1.x * l1 - a2.x * l2, c.y + a1.y * l1- a2.y * l2, c.z + a1.z * l1 - a2.z * l2);
+      glEnd();
+
+      if( drawMode & DRAW_BV_BLENDED)
+        glColor4f(color.x, color.y, color.z, 1.0);
 
     }
@@ -1127,10 +941,7 @@
 void OBBTreeNode::debug() const
 {
-
-  /*
-  for(int i = 0; i < length; i++)
-  {
-  PRINTF(3)("vertex %i: %f, %f, %f\n", i, verticesList[i][0], verticesList[i][1], verticesList[i][2]);
-}
-  */
-}
+  PRINT(0)("========OBBTreeNode::debug()=====\n");
+  PRINT(0)(" Current depth: %i", this->depth);
+  PRINT(0)(" ");
+  PRINT(0)("=================================\n");
+}
Index: trunk/src/lib/collision_detection/obb_tree_node.h
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.h	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree_node.h	(revision 7711)
@@ -1,6 +1,5 @@
 /*!
  * @file bv_tree.h
-  *  Definition of a bounding volume tree
-
+ *  Definition of a bounding volume tree
  */
 
@@ -8,9 +7,8 @@
 #define _OBB_TREE_NODE_H
 
+
 #include "bv_tree_node.h"
+#include "plane.h"
 
-
-
-// FORWARD DECLARATION
 class BoundingVolume;
 class OBB;
@@ -18,66 +16,66 @@
 class Plane;
 class PNode;
-//struct sVec3D;
+
 
 //! A class that represents a bounding volume tree
-class OBBTreeNode : public BVTreeNode {
+class OBBTreeNode : public BVTreeNode
+{
 
 
   public:
-    OBBTreeNode();
+    OBBTreeNode(const OBBTree& tree, OBBTreeNode* prev, int depth);
     virtual ~OBBTreeNode();
 
-    virtual void spawnBVTree(const int depth, const sVec3D *verticesList, unsigned int length);
-    virtual void spawnBVTree(const int depth, const modelInfo& modInfo);
+    /**  this function returns the bounding volume of this tree node @return: returns the BV */
+    virtual inline const BoundingVolume* getBV() const { return (BoundingVolume*)this->bvElement; }
 
-    BoundingVolume* getBV(int index) const { return (BoundingVolume*)this->bvElement; }
-    inline const int getIndex() { return this->treeIndex; }
-    inline void setTreeRef(OBBTree* tree) { this->obbTree = tree;}
+    virtual void spawnBVTree(const modelInfo& modelInf, const int* triangleIndexes, int length);
 
     virtual void collideWith(BVTreeNode* treeNode, WorldEntity* nodeA, WorldEntity* nodeB);
-
     virtual void drawBV(int depth, int drawMode, const Vector& color = Vector(1,0,0), bool top = true) const;
-
     void debug() const;
 
-  private:
-    void calculateBoxCovariance(OBB* box, const sVec3D* verticesList, unsigned int length);
-    void calculateBoxEigenvectors(OBB* box, const sVec3D* verticesList, unsigned int length);
-    void calculateBoxAxis(OBB* box, const sVec3D* verticesList, unsigned int length);
-
-    void calculateBoxCovariance(OBB* box, const modelInfo& modInfo);
-    void calculateBoxEigenvectors(OBB* box, const modelInfo& modInfo);
-    void calculateBoxAxis(OBB* box, const modelInfo& modInfo);
+    /**  gets the id of the current child @return id of the child */
+    inline const int getID() { return this->nextID++; }
 
 
-    void forkBox(OBB* box);
+  private:
+    void calculateBoxAxis(OBB& box, const sVec3D* verticesList, unsigned int length);
 
-    bool overlapTest(OBB* boxA, OBB* boxB, WorldEntity* nodeA, WorldEntity* nodeB);
+    void calculateBoxCovariance(OBB& box, const modelInfo& modelInf, const int* triangleIndexes, int length);
+    void calculateBoxEigenvectors(OBB& box, const modelInfo& modelInf, const int* triangleIndexes, int length);
+    void calculateBoxAxis(OBB& box, const modelInfo& modelInf, const int* triangleIndexes, int length);
+    void forkBox(OBB& box);
+
+    bool overlapTest(OBB& boxA, OBB& boxB, WorldEntity* nodeA, WorldEntity* nodeB);
+
 
   protected:
     OBB*                bvElement;                  //!< the obb element
+    OBBTreeNode*        nodePrev;                   //!< ref to the previous (parent) tree node = NULL if first
     OBBTreeNode*        nodeLeft;                   //!< ref to the left tree node
     OBBTreeNode*        nodeRight;                  //!< ref to the right tree node
 
+
   private:
-    unsigned int        treeIndex;                  //!< Index number of the BV in the tree
-    const sVec3D*       vertices;                   //!< pointer to the vertices data
-    int                 numOfVertices;              //!< number of vertices in vertices data
+    int                 treeIndex;                  //!< Index number of the BV in the tree
+    int                 nextID;                     //!< the id of the next child
     int                 depth;                      //!< the depth of the node in the tree
-    static OBBTree*     obbTree;                    //!< reference to the obb tree
-    Plane*              separationPlane;            //!< the separation plane of the obb
-    const sVec3D*       sepPlaneCenter;             //!< only needed to draw plane
+    const OBBTree*      obbTree;                    //!< reference to the obb tree
+
+    const modelInfo*    modelInf;                   //!< pointer to the models modelInfo object
+    const int*          triangleIndexes;            //!< indexes to the used model triangles
+
+    Plane               separationPlane;            //!< the separation plane of the obb
+    sVec3D              sepPlaneCenter;             //!< only needed to draw plane
     int                 longestAxisIndex;           //!< only needed to draw plane
 
     /* tmp saving place for obb variables */
-    sVec3D*             tmpVert1;                   //!< pointer to the vert data of obbox1
-    sVec3D*             tmpVert2;                   //!< pointer to the vert data of obbox1
-    int                 tmpLen1;                    //!< len vert data obbox1
-    int                 tmpLen2;                    //!< len vert data obbox2
+    int*                triangleIndexList1;         //!< pointer to the vert data of obbox1
+    int*                triangleIndexList2;         //!< pointer to the vert data of obbox1
+    int                 triangleIndexLength1;       //!< len vert data obbox1
+    int                 triangleIndexLength2;       //!< len vert data obbox2
 
-    static float**      coMat;
-    static float**      eigvMat;
-    static float*       eigvlMat;
-    static int*         rotCount;
+    WorldEntity*        owner;
 };
 
Index: trunk/src/lib/graphics/importer/static_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/static_model.cc	(revision 7677)
+++ trunk/src/lib/graphics/importer/static_model.cc	(revision 7711)
@@ -196,4 +196,5 @@
   this->buildTriangleList();
 
+  // write out the modelInfo data used for the collision detection!
   this->pModelInfo.pVertices = &this->vertices[0];
   this->pModelInfo.pNormals = &this->normals[0];
@@ -805,9 +806,11 @@
     this->buildVertexNormals();
 
-  int index = 0;                   //!< the counter for the triangle array
-  ModelFaceElement* tmpElem;       //!< the temporary faceelement reference
-  ModelFace* tmpFace;              //!< the temporary face referece
+  int                index = 0;                   //!< the counter for the triangle array
+  ModelFaceElement*  tmpElem;       //!< the temporary faceelement reference
+  ModelFace*         tmpFace;              //!< the temporary face referece
 
   bool warned = false;
+
+  this->pModelInfo.numTriangles = 0;
 
   /* count the number of triangles */
@@ -819,22 +822,16 @@
     while( tmpFace != NULL)
     {
-
       /* if its a triangle just add it to the list */
-      if( tmpFace->vertexCount == 3)
-      {
+      if( tmpFace->vertexCount == 3){
         ++this->pModelInfo.numTriangles;
       } /* if the polygon is a quad */
-      else if( tmpFace->vertexCount == 4)
-      {
+      else if( tmpFace->vertexCount == 4) {
         this->pModelInfo.numTriangles += 2;
       }
-      else if( tmpFace->vertexCount > 4)
-      {
-        if (!warned)
-        {
+      else if( tmpFace->vertexCount > 4) {
+        if (!warned)        {
           PRINTF(2)("This model (%s) got over 4 vertices per face <=> conflicts in the CD engine!\n", this->getName());
           warned = true;
         }
-        //exit(0);
       }
       tmpFace = tmpFace->next;
@@ -859,5 +856,4 @@
   while( this->currentGroup != NULL)
   {
-    // Putting Faces to GL
     tmpFace = this->currentGroup->firstFace;
     while( tmpFace != NULL)
@@ -870,8 +866,9 @@
         for( int j = 0; j < 3; ++j)
         {
-          this->pModelInfo.pTriangles[index].indexToVertices[j] = (unsigned int)tmpElem->vertexNumber /* * 3 */;
-          this->pModelInfo.pTriangles[index].indexToNormals[j] = (unsigned int)tmpElem->normalNumber /* * 3 */;
-          this->pModelInfo.pTriangles[index].indexToTexCoor[j] = (unsigned int)tmpElem->texCoordNumber /* * 3 */;
+          this->pModelInfo.pTriangles[index].indexToVertices[j] = (unsigned int)tmpElem->vertexNumber * 3 ;
+          this->pModelInfo.pTriangles[index].indexToNormals[j] = (unsigned int)tmpElem->normalNumber * 3 ;
+          this->pModelInfo.pTriangles[index].indexToTexCoor[j] = (unsigned int)tmpElem->texCoordNumber * 3 ;
           tmpElem = tmpElem->next;
+
         }
         ++index;
@@ -880,30 +877,30 @@
       {
 
-        this->pModelInfo.pTriangles[index].indexToVertices[0] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index].indexToNormals[0] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index].indexToTexCoor[0] = (unsigned int)tmpElem->texCoordNumber;
-
-        this->pModelInfo.pTriangles[index + 1].indexToVertices[0] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToNormals[0] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[0] = (unsigned int)tmpElem->texCoordNumber;
+        this->pModelInfo.pTriangles[index].indexToVertices[0] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToNormals[0] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToTexCoor[0] = (unsigned int)tmpElem->texCoordNumber * 3;
+
+        this->pModelInfo.pTriangles[index + 1].indexToVertices[0] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToNormals[0] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[0] = (unsigned int)tmpElem->texCoordNumber * 3;
         tmpElem = tmpElem->next;
 
-        this->pModelInfo.pTriangles[index].indexToVertices[1] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index].indexToNormals[1] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index].indexToTexCoor[1] = (unsigned int)tmpElem->texCoordNumber;
+        this->pModelInfo.pTriangles[index].indexToVertices[1] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToNormals[1] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToTexCoor[1] = (unsigned int)tmpElem->texCoordNumber * 3;
         tmpElem = tmpElem->next;
 
-        this->pModelInfo.pTriangles[index].indexToVertices[2] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index].indexToNormals[2] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index].indexToTexCoor[2] = (unsigned int)tmpElem->texCoordNumber;
-
-        this->pModelInfo.pTriangles[index + 1].indexToVertices[2] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToNormals[2] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[2] = (unsigned int)tmpElem->texCoordNumber;
+        this->pModelInfo.pTriangles[index].indexToVertices[2] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToNormals[2] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index].indexToTexCoor[2] = (unsigned int)tmpElem->texCoordNumber * 3;
+
+        this->pModelInfo.pTriangles[index + 1].indexToVertices[2] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToNormals[2] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[2] = (unsigned int)tmpElem->texCoordNumber * 3;
         tmpElem = tmpElem->next;
 
-        this->pModelInfo.pTriangles[index + 1].indexToVertices[1] = (unsigned int)tmpElem->vertexNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToNormals[1] = (unsigned int)tmpElem->normalNumber;
-        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[1] = (unsigned int)tmpElem->texCoordNumber;
+        this->pModelInfo.pTriangles[index + 1].indexToVertices[1] = (unsigned int)tmpElem->vertexNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToNormals[1] = (unsigned int)tmpElem->normalNumber * 3;
+        this->pModelInfo.pTriangles[index + 1].indexToTexCoor[1] = (unsigned int)tmpElem->texCoordNumber * 3;
 
         index += 2;
Index: trunk/src/lib/math/matrix.cc
===================================================================
--- trunk/src/lib/math/matrix.cc	(revision 7677)
+++ trunk/src/lib/math/matrix.cc	(revision 7711)
@@ -244,4 +244,6 @@
 
     eigVc3 = eigVc1.cross(eigVc2);
+
+    eigVc2 = eigVc3.cross(eigVc1);
   }
   else if (eigenValuesCount == 1)
@@ -254,4 +256,11 @@
   eigVc2.normalize();
   eigVc3.normalize();
+
+  if (!(eigVc1.cross(eigVc3) == eigVc2))
+  {
+    eigVc3.cross(eigVc1);
+//     eigVc2.debug();
+  }
+/*  printf("ok\n")*/;
 }
 
Index: trunk/src/lib/math/plane.cc
===================================================================
--- trunk/src/lib/math/plane.cc	(revision 7677)
+++ trunk/src/lib/math/plane.cc	(revision 7711)
@@ -222,4 +222,5 @@
 }
 
+
 /**
  *  calculate the two points of minimal distance of two lines
@@ -267,5 +268,5 @@
 {
   n = (a-b).cross(c-b);
-  k = -(n.x*b.x+n.y*b.y+n.z*b.z);
+  k = n.dot(a) / n.len();
 }
 
@@ -278,5 +279,5 @@
 {
   n = norm;
-  k = -(n.x*p.x+n.y*p.y+n.z*p.z);
+  k = n.dot(p) / n.len();
 }
 
@@ -291,5 +292,5 @@
   Vector p(g[0], g[1], g[2]);
   n = norm;
-  k = -(n.x*p.x+n.y*p.y+n.z*p.z);
+  k = n.dot(p) / n.len();
 }
 
@@ -315,5 +316,5 @@
   float l = n.len();
   if( l == 0.0) return 0.0;
-  return (n.dot(p) + k) / n.len();
+  return (n.dot(p) / n.len() - k);
 }
 
@@ -324,10 +325,25 @@
  * @return the distance between the plane and the point (can be negative)
  */
-float Plane::distancePoint (const sVec3D& p) const
+// float Plane::distancePoint (const sVec3D& p) const
+// {
+//   Vector s(p[0], p[1], p[2]);
+//   float l = n.len();
+//   if( l == 0.0) return 0.0;
+//   return (n.dot(s) + k) / n.len();
+// }
+
+
+/**
+ *  returns the distance between the plane and a point
+ * @param p: a Point
+ * @return the distance between the plane and the point (can be negative)
+ */
+float Plane::distancePoint (const float* p) const
 {
   Vector s(p[0], p[1], p[2]);
+
   float l = n.len();
   if( l == 0.0) return 0.0;
-  return (n.dot(s) + k) / n.len();
+  return (n.dot(s) / n.len() - k);
 }
 
Index: trunk/src/lib/math/plane.h
===================================================================
--- trunk/src/lib/math/plane.h	(revision 7677)
+++ trunk/src/lib/math/plane.h	(revision 7711)
@@ -51,5 +51,6 @@
   Vector intersectLine (const Line& l) const;
   float distancePoint (const Vector& p) const;
-  float distancePoint (const sVec3D& p) const;
+//   float distancePoint (const sVec3D& p) const;
+  float distancePoint (const float* p) const;
   float locatePoint (const Vector& p) const;
 };
Index: trunk/src/lib/math/vector.h
===================================================================
--- trunk/src/lib/math/vector.h	(revision 7677)
+++ trunk/src/lib/math/vector.h	(revision 7711)
@@ -85,4 +85,5 @@
   /** copy constructor* @param v the sVec3D to assign to this vector. @returns the vector v */
   inline const Vector& operator= (const sVec3D& v) { this->x = v[0]; this->y = v[1]; this->z = v[2]; }
+  inline const Vector& operator= (const float* v) { this->x = v[0]; this->y = v[1]; this->z = v[2]; }
   /** @param v: the other vector \return the dot product of the vectors */
   float dot (const Vector& v) const { return x*v.x+y*v.y+z*v.z; };
Index: trunk/src/lib/util/executor/executor_specials.h
===================================================================
--- trunk/src/lib/util/executor/executor_specials.h	(revision 7677)
+++ trunk/src/lib/util/executor/executor_specials.h	(revision 7711)
@@ -8,4 +8,5 @@
 
 #include "executor.h"
+#include "compiler.h"
 
 #include "compiler.h"
Index: trunk/src/lib/util/executor/functor_list.h
===================================================================
--- trunk/src/lib/util/executor/functor_list.h	(revision 7677)
+++ trunk/src/lib/util/executor/functor_list.h	(revision 7711)
@@ -140,5 +140,5 @@
 
   FUNCTOR_LIST(3)(l_STRING, l_FLOAT, l_UINT);
-
+  FUNCTOR_LIST(4)(l_STRING, l_FLOAT, l_UINT, l_UINT);
 
 #endif /* FUNCTOR_LIST */
